<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_stats_provider".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanStatsProvider".
 *
 * Columns in table "scan_stats_provider" available as properties of the model,
 * followed by relations of table "scan_stats_provider" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_input_provider_id
 * @property integer $listing_accuracy
 * @property integer $missing_listing
 * @property integer $profile_completion_score
 * @property integer $completed_scans
 * @property integer $cnt_errors
 * @property integer $data_element
 * @property string $reviews_average
 * @property integer $total_reviews
 * @property integer $healthgrades_reviews
 * @property string $healthgrades_primary_specialty
 * @property string $reviews_grade
 * @property string $missing_listing_names
 * @property string $profile_completion_missing_data
 * @property integer $op_score
 *
 * @property ScanRequestProvider $scanInputProvider
 */
abstract class BaseScanStatsProvider extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_stats_provider';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanStatsProvider|ScanStatsProviders', $n);
    }

    public static function representingColumn()
    {
        return 'reviews_average';
    }

    public function rules()
    {
        return array(
            array('scan_input_provider_id', 'required'),
            array('scan_input_provider_id, listing_accuracy, missing_listing, profile_completion_score, completed_scans, cnt_errors, data_element, total_reviews, healthgrades_reviews, op_score', 'numerical', 'integerOnly' => true),
            array('reviews_average, reviews_grade', 'length', 'max' => 3),
            array('healthgrades_primary_specialty', 'length', 'max' => 255),
            array('missing_listing_names, profile_completion_missing_data', 'safe'),
            array('listing_accuracy, missing_listing, profile_completion_score, completed_scans, cnt_errors, data_element, reviews_average, total_reviews, healthgrades_reviews, healthgrades_primary_specialty, reviews_grade, missing_listing_names, profile_completion_missing_data, op_score', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_input_provider_id, listing_accuracy, missing_listing, profile_completion_score, completed_scans, cnt_errors, data_element, reviews_average, total_reviews, healthgrades_reviews, healthgrades_primary_specialty, reviews_grade, missing_listing_names, profile_completion_missing_data, op_score', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanInputProvider' => array(self::BELONGS_TO, 'ScanRequestProvider', 'scan_input_provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_input_provider_id' => null,
            'listing_accuracy' => Yii::t('app', 'Listing Accuracy'),
            'missing_listing' => Yii::t('app', 'Missing Listing'),
            'profile_completion_score' => Yii::t('app', 'Profile Completion Score'),
            'completed_scans' => Yii::t('app', 'Completed Scans'),
            'cnt_errors' => Yii::t('app', 'Cnt Errors'),
            'data_element' => Yii::t('app', 'Data Element'),
            'reviews_average' => Yii::t('app', 'Reviews Average'),
            'total_reviews' => Yii::t('app', 'Total Reviews'),
            'healthgrades_reviews' => Yii::t('app', 'Healthgrades Reviews'),
            'healthgrades_primary_specialty' => Yii::t('app', 'Healthgrades Primary Specialty'),
            'reviews_grade' => Yii::t('app', 'Reviews Grade'),
            'missing_listing_names' => Yii::t('app', 'Missing Listing Names'),
            'profile_completion_missing_data' => Yii::t('app', 'Profile Completion Missing Data'),
            'op_score' => Yii::t('app', 'Op Score'),
            'scanInputProvider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_input_provider_id', $this->scan_input_provider_id);
        $criteria->compare('listing_accuracy', $this->listing_accuracy);
        $criteria->compare('missing_listing', $this->missing_listing);
        $criteria->compare('profile_completion_score', $this->profile_completion_score);
        $criteria->compare('completed_scans', $this->completed_scans);
        $criteria->compare('cnt_errors', $this->cnt_errors);
        $criteria->compare('data_element', $this->data_element);
        $criteria->compare('reviews_average', $this->reviews_average, true);
        $criteria->compare('total_reviews', $this->total_reviews);
        $criteria->compare('healthgrades_reviews', $this->healthgrades_reviews);
        $criteria->compare('healthgrades_primary_specialty', $this->healthgrades_primary_specialty, true);
        $criteria->compare('reviews_grade', $this->reviews_grade, true);
        $criteria->compare('missing_listing_names', $this->missing_listing_names, true);
        $criteria->compare('profile_completion_missing_data', $this->profile_completion_missing_data, true);
        $criteria->compare('op_score', $this->op_score);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
